package de.hanser.buch.opiz.domain;

import junit.framework.TestCase;
import org.hibernate.SessionFactory;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.Query;
import org.hibernate.cfg.AnnotationConfiguration;

import java.util.List;

/**
 * Demonstriert die delete-Methode.
 *
 * @author Stefan Wille
 */
public class DeleteTest extends TestCase {
    private SessionFactory sessionFactory;
    private Session session;
    private Integer id;
    private Pizza pizza;

    @Override
    protected void setUp() throws Exception {
        super.setUp();

        sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
        session = sessionFactory.openSession();
        Transaction transaction = session.beginTransaction();

        pizza = new Pizza();
        pizza.setName("Thunfisch");

        session.save(pizza);

        id = pizza.getId();

        transaction.commit();
    }

    @Override
    protected void tearDown() throws Exception {
        super.tearDown();

        session.close();
        sessionFactory.close();
    }

    @SuppressWarnings({"unchecked"})
    public void testDelete() {

        Transaction transaction = session.beginTransaction();

        session.delete(pizza);

        Query query = session.createQuery("select p from Pizza p where p.id=?");
        query.setInteger(0, id);
        List<Pizza> pizzas = (List<Pizza>) query.list();

        assertEquals(0, pizzas.size());
        transaction.commit();

    }

}
