package de.hanser.buch.opiz.domain;

import junit.framework.TestCase;
import org.hibernate.SessionFactory;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.cfg.AnnotationConfiguration;

/**
 * Demonstriert die save-Methode.
 *
 * @author Stefan Wille
 */
public class GetTest extends TestCase {
    private SessionFactory sessionFactory;
    private Session session;

    @Override
    protected void setUp() throws Exception {
        super.setUp();

        sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
        session = sessionFactory.openSession();
    }

    @Override
    protected void tearDown() throws Exception {
        session.close();
        sessionFactory.close();

        super.tearDown();
    }

    public void testGet() {
        Transaction transaction = session.beginTransaction();
        Pizza pizza = new Pizza();
        pizza.setName("Thunfisch");
        session.save(pizza);
        Integer id = pizza.getId();
        transaction.commit();

        transaction = session.beginTransaction();
        Pizza reloadedPizza = (Pizza) session.get(Pizza.class, id);
        assertNotNull(reloadedPizza);
        assertEquals("Thunfisch", reloadedPizza.getName());
        transaction.commit();
    }

}
