package de.hanser.buch.opiz.domain;

import junit.framework.TestCase;
import org.hibernate.SessionFactory;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.Query;
import org.hibernate.cfg.AnnotationConfiguration;

import java.util.List;

/**
 * Demonstriert die save-Methode.
 *
 * @author Stefan Wille
 */
public class QueryTest extends TestCase {
    private SessionFactory sessionFactory;
    private Session session;

    @Override
    protected void setUp() throws Exception {
        super.setUp();

        sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
        session = sessionFactory.openSession();
        Transaction transaction = session.beginTransaction();

        Pizza pizza = new Pizza();
        pizza.setName("Thunfisch");

        session.save(pizza);

        transaction.commit();
    }

    @Override
    protected void tearDown() throws Exception {
        super.tearDown();

        session.close();
        sessionFactory.close();
    }

    public void testQuery() {

        Transaction transaction = session.beginTransaction();

        Query query = session.createQuery("select p from Pizza p where p.name = ?");
        query.setString(0, "Thunfisch");
        List list = query.list();

        Pizza pizza = (Pizza) list.get(0);
        assertEquals("Thunfisch", pizza.getName());

        transaction.commit();

    }

}
