package de.hanser.buch.opiz.domain;

import junit.framework.TestCase;
import org.hibernate.SessionFactory;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.cfg.AnnotationConfiguration;

/**
 * Demonstriert die save-Methode.
 *
 * @author Stefan Wille
 */
public class UpdateTest extends TestCase {
    private SessionFactory sessionFactory;
    private Session session;
    private Integer id;

    @Override
    protected void setUp() throws Exception {
        super.setUp();

        sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
        session = sessionFactory.openSession();
        Transaction transaction = session.beginTransaction();

        Pizza pizza = new Pizza();
        pizza.setName("Thunfisch");

        session.save(pizza);

        id = pizza.getId();

        transaction.commit();
    }

    @Override
    protected void tearDown() throws Exception {
        super.tearDown();

        session.close();
        sessionFactory.close();
    }

    public void testUpdate() {
        Transaction transaction1 = session.beginTransaction();

        Pizza pizza = (Pizza) session.load(Pizza.class, id);
        assertEquals("Thunfisch", pizza.getName());

        // Die Pizza verndern - nderungen gehen automatisch in die Datenbank.
        pizza.setName("Salami");

        transaction1.commit();

        Transaction transaction2 = session.beginTransaction();

        Pizza reloadedPizza = (Pizza) session.load(Pizza.class, id);
        assertEquals("Salami", reloadedPizza.getName());

        transaction2.commit();
    }
}
