package de.hanser.buch.opiz.domain;

import junit.framework.TestCase;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;

/**
 * Basisklasse fr die Tests in diesem Kapitel.
 * Sptere Kapitel verwenden eine Basisklasse aus Spring fr die Tests.
 */
public abstract class AbstractHibernateTest extends TestCase {
    protected Session session;
    protected SessionFactory sessionFactory;

    @Override
    protected void setUp() throws Exception {
        super.setUp();

        sessionFactory = new AnnotationConfiguration().configure().buildSessionFactory();
        session = sessionFactory.openSession();
    }

    @Override
    protected void tearDown() throws Exception {
        session.close();
        sessionFactory.close();

        super.tearDown();
    }
}
