package de.hanser.buch.opiz.domain;

import org.hibernate.Transaction;
import org.hibernate.Query;

import java.util.Arrays;

/**
 * Demonstriert das Mapping von Blobs.
 */
public class BlobTest extends AbstractHibernateTest {

    public void testSaveAndQueryPicture() {
        Transaction transaction = session.beginTransaction();

        // 100.000 Bytes kann kaum eine Datenbank in einer Spalte speichern.
        // Es sei denn in einem Blob.
        Picture picture = new Picture();
        byte[] data = new byte[100000];
        for (int i = 0; i < data.length; i++) {
            data[i] = (byte) i;
        }
        picture.setData(data);

        session.save(picture);

        session.flush();

        session.clear();

        Query query = session.createQuery("from Picture");
        Picture loadedPicture = (Picture) query.uniqueResult();
        assertEquals(data.length, loadedPicture.getData().length);
        assertTrue(Arrays.equals(data, loadedPicture.getData()));

        transaction.commit();
    }

}
