package de.hanser.buch.opiz.domain;

import org.hibernate.Transaction;
import org.hibernate.Query;

import java.util.List;

/**
 * Demonstriert Vererbung und eine polymorphe Query.
 *
 * @author Stefan Wille
 */
public class InheritanceSingleClassTest extends AbstractHibernateTest {

    @SuppressWarnings({"unchecked"})
    public void testInheritance() {
        Transaction transaction = session.beginTransaction();

        Customer customer = new Customer();
        customer.setName("Malte Mustermann");
        customer.setUsername("maltem");
        customer.setPassword("geheim");
        session.save(customer);

        Supplier supplier = new Supplier();
        supplier.setName("Mommys Ketchup Shop");
        supplier.setBillsDueInDays(30);
        session.save(supplier);

        // Fhre eine polymorphe Query aus.
        Query query = session.createQuery("select b from BusinessPartner b where b.name like 'M%'");
        List<BusinessPartner> l = query.list();

        assertEquals(2, l.size());
        assertTrue(l.contains(customer));
        assertTrue(l.contains(supplier));

        transaction.commit();
    }

}
