package de.hanser.buch.opiz.domain;

import org.hibernate.Query;
import org.hibernate.Transaction;


/**
 * Demonstriert die unidirektionale N:1-Beziehung zwischen Customer und Order.
 *
 * @author Stefan Wille
 */
public class UniDirectionalManyToOneTest extends AbstractHibernateTest {

    public void testAssociation() {
        Transaction transaction = session.beginTransaction();

        // Erzeuge einen Kunden
        Customer customer = new Customer();
        customer.setName("Georg Brauchle");
        customer.setUsername("gbrauchle");
        session.save(customer);

        // Erzeuge eine Bestellung
        Order order = new Order();
        session.save(order);

        // Und stelle die Beziehung zwischen den beiden Objekten her.
        order.setCustomer(customer);

        // Fhre eine Query auf der Basis der Beziehung durch.
        Query query = session.createQuery("select o from Order o where o.customer.name like 'G%'");
        Order o = (Order) query.uniqueResult();
        assertSame(order, o);

        transaction.commit();
    }

}
