package de.hanser.buch.opiz.domain;

import org.hibernate.Transaction;
import org.hibernate.Query;

/**
 * Demonstriert die unidirektionale 1:1-Beziehung zwischen Customer und Address.
 *
 * @author Stefan Wille
 */
public class UniDirectionalOneToOneTest extends AbstractHibernateTest {

    public void testAssociation() {
        Transaction transaction = session.beginTransaction();

        Customer customer = new Customer();
        Address address = new Address();
        customer.setAddress(address);
        session.save(customer);

        // Fhre eine Query auf der Basis der Beziehung durch.
        Query query = session.createQuery("select c.address from Customer c");
        Address a = (Address) query.uniqueResult();
        assertSame(address, a);

        transaction.commit();
    }

}
