package de.hanser.buch.opiz.auth;

import org.acegisecurity.userdetails.UserDetails;
import org.acegisecurity.userdetails.UserDetailsService;

import de.hanser.buch.opiz.domain.Customer;

/**
 * Interfacce des Services fr die Authentifizierung eines Kunden.
 */
public interface CustomerAuthService extends UserDetailsService {

    public static final String ROLE_CUSTOMER = "ROLE_CUSTOMER";

    /**
     * Liefert die Benutzerinformation zu einem registrierten Kunden.
     * @param customer der Kunde
     * @return die Benutzerinformation
     */
    public UserDetails getUserDetails(Customer customer);

    /**
     * Authentifiziert einen Benutzer.
     * @param userDetails die Benutzerinformation
     * @param credentials der Berechtigungsnachweis
     */
    public void authenticate(UserDetails userDetails, Object credentials);

    
    /**
     * Liefert den aktuell angemeldeten Kunden.
     * @return der Kunde
     */
    public Customer getPrincipal();
    
}
