package de.hanser.buch.opiz.auth;

import org.acegisecurity.GrantedAuthority;
import org.acegisecurity.userdetails.User;

import de.hanser.buch.opiz.domain.Customer;

/**
 * Die Information zu einem angemeldeten Kunden.
 */
@SuppressWarnings("serial")
public class CustomerUserDetail extends User {

    private Customer customer;
    
    public CustomerUserDetail(Customer customer, GrantedAuthority[] grants) throws IllegalArgumentException {
        super(customer.getUsername(), customer.getPassword(), true, true, true, true, grants);
        this.customer = customer;
    } 
    
    @Override
    public String getUsername() {
        return customer.getUsername();
    }

    @Override
    public String getPassword() {
        return customer.getPassword();
    }
    
    public Customer getCustomer() {
        return customer;
    }
}
