package de.hanser.buch.opiz.web;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;

import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import de.hanser.buch.opiz.dao.ToppingDao;
import de.hanser.buch.opiz.domain.Topping;
import de.hanser.buch.opiz.domain.ToppingPriceCategory;

/**
 * Initialisierungs-Servlet (wird beim Start der Anwendung aufgerufen).
 */
@SuppressWarnings("serial")
public class ApplicationInit extends HttpServlet {

	/**
	 * Wird beim Start des Servlets aufgerufen.
	 *
	 * @throws ServletException Fehler bei der Initialisierung
	 */
	public void init() throws ServletException {
		WebApplicationContext appContext = WebApplicationContextUtils.getWebApplicationContext(getServletContext());
		ToppingDao toppingDao = (ToppingDao) appContext.getBean("toppingDao");
		toppingDao.saveTopping(new Topping("Tomaten", ToppingPriceCategory.ONE));
		toppingDao.saveTopping(new Topping("Kse", ToppingPriceCategory.ONE));
		toppingDao.saveTopping(new Topping("Ananas", ToppingPriceCategory.TWO));
		toppingDao.saveTopping(new Topping("Thunfisch", ToppingPriceCategory.TWO));
		toppingDao.saveTopping(new Topping("Salami", ToppingPriceCategory.TWO));
		toppingDao.saveTopping(new Topping("Ruccola", ToppingPriceCategory.THREE));
	}
}
