package de.hanser.buch.opiz.web;

import java.io.IOException;
import java.util.Locale;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import org.springframework.context.i18n.LocaleContextHolder;

/**
 * Filter fr das Setzen der aktuellen Spracheinstellung.
 */
public class LocaleFilter implements Filter {

	public void init(FilterConfig config) throws ServletException {
	}

	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain chain) throws IOException, ServletException {

		Locale locale = request.getLocale();
		// Spracheinstellung fr den aktuellen Thread setzen (Spring)
		LocaleContextHolder.setLocale(locale);
		chain.doFilter(request, response);
		LocaleContextHolder.setLocaleContext(null);
	}

	public void destroy() {
	}
}
