package de.hanser.buch.opiz.web.jsf;

import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;

import de.hanser.buch.opiz.domain.Pizza;

/**
 * Konvertiert Auswahllisteneintrge in Domain-Objekte und andersherum. Hier
 * wird die Auswahl einer Pizza in ein Pizza-Objekte konvertiert.
 */
public class PizzaConverter implements Converter {

    public Object getAsObject(FacesContext ctx, UIComponent component, String value) {
        Pizza selectedPizza = null;
        if ((value == null) || value.length() == 0) {
            throw new ConverterException("error.pizzaNull");
        }

        // Mit dem Namen das Pizza-Objekt aus der "managed" Liste holen.
        Application app = ctx.getApplication();
        PizzaList typeList = (PizzaList) app.evaluateExpressionGet(ctx, "#{pizzasList}", PizzaList.class);
        selectedPizza = typeList.getObjectByKey(value);
        if (selectedPizza == null) {
            throw new ConverterException("error.pizzaConversion");
        }
        return selectedPizza;
    }

    public String getAsString(FacesContext ctx, UIComponent component, Object value) {
        if (value == null) {
            return null;
        }
        return ((Pizza) value).getName();
    }
}
