package de.hanser.buch.opiz.web.jsf;

import java.util.ArrayList;

import de.hanser.buch.opiz.dao.ToppingDao;
import de.hanser.buch.opiz.domain.Pizza;
import de.hanser.buch.opiz.domain.Topping;

/**
 * Globale Liste der im System verfuegbaren Pizzen.
 */
public class PizzaList extends AbstractSelectionList<Pizza> {

	private ToppingDao toppingDao;
	
    /** 
     * Fuellt die Auswahlliste mit Pizzen.
     * Der Inhalt ist statisch und wrde in einer "richtigen" Anwendung
     * aus der Datenbank gelesen werden. 
     */
    protected void fillSelectionList() {
        
        Topping tomato = toppingDao.getToppingByName("Tomaten").get(0);
        Topping cheese = toppingDao.getToppingByName("Kse").get(0);
        Topping ananas = toppingDao.getToppingByName("Ananas").get(0);

        Pizza margarita = new Pizza("Margherita", new ArrayList<Topping>());
        margarita.addTopping(tomato);
        margarita.addTopping(cheese);
        addSelectionItem(margarita);

        Pizza hawaii = new Pizza("Hawaii", new ArrayList<Topping>());
        hawaii.addTopping(tomato);
        hawaii.addTopping(cheese);
        hawaii.addTopping(ananas);
        addSelectionItem(hawaii);
    }
    
    // Fgt das konkrete Objekt der Liste hinzu
    private void addSelectionItem(Pizza pizza) {
        addSelectionItem(pizza.getName(), pizza);
    }
    
    public void setToppingDao(ToppingDao toppingDao) {
        this.toppingDao = toppingDao;
    }
}
