package de.hanser.buch.opiz.web.jsf;

import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;

import de.hanser.buch.opiz.domain.Topping;

/**
 * Konvertiert Auswahllisteneintrge in Domain-Objekte und andersherum. Hier
 * wird die Auswahl eines Pizzabelages in ein Topping-Objekt konvertiert.
 */
public class ToppingConverter implements Converter {

    public Object getAsObject(FacesContext ctx, UIComponent component,
            String value) {
        Topping selectedTopping = null;
        if ((value == null) || value.length() == 0) {
            throw new ConverterException("error.toppingNull");
        }

        // Mit dem Namen das Topping-Objekt aus der "managed" Liste holen.
        Application app = ctx.getApplication();
        ToppingList typeList = (ToppingList) app.evaluateExpressionGet(ctx,
                "#{toppingsList}", ToppingList.class);
        selectedTopping = typeList.getObjectByKey(value);
        if (selectedTopping == null) {
            throw new ConverterException("error.toppingConversion");
        }
        return selectedTopping;
    }

    public String getAsString(FacesContext ctx, UIComponent component,
            Object value) {
        return ((Topping) value).getName();
    }
}
