package de.hanser.buch.test;

import java.util.HashMap;
import java.util.Map;

import org.apache.shale.test.base.AbstractJsfTestCase;
import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * Basisklasse fr Unit-Tests, die Spring und JSF kombinieren.
 */
public abstract class BaseJsfSpringTestCase extends AbstractJsfTestCase {

    private static Map<String, ConfigurableApplicationContext> cm = new HashMap<String, ConfigurableApplicationContext>();

    public BaseJsfSpringTestCase() {
        super("name");
    }

    public BaseJsfSpringTestCase(String name) {
        super(name);
    }

    protected ConfigurableApplicationContext getAppContext(String key) {
        ConfigurableApplicationContext context = cm.get(key);
        if (context == null) {
            context = new ClassPathXmlApplicationContext(getContextLocations());
            cm.put(key, context);
        }
        return context;
    }

    @Override
    protected final void setUp() throws Exception {
        super.setUp();
        onSetup();
    }

    /**
     * @return Array von Kontextdateien
     */
    protected abstract String[] getContextLocations();

    /**
     * Test initialisieren.
     */
    protected void onSetup() {
    }
}
