package de.hanser.buch.opiz.ejb;

import java.rmi.RemoteException;
import java.util.List;

import javax.ejb.EJBObject;

import de.hanser.buch.opiz.domain.Order;
import de.hanser.buch.opiz.domain.OrderFilter;

public interface OrderServiceEjbRemote extends EJBObject {
    /**
     * Gibt eine Liste von Order-Objekten zurück, die das Filter entsprechen.
     * 
     * @param filter
     *            das Filter-Objekt.
     * @return eine Liste von Order-Objekten.
     */
    List<Order> selectOrder(OrderFilter filter)
            throws RemoteException;

    Integer createPendingOrder(Integer aPizzaId)
            throws RemoteException;

    public boolean finishOrder(Integer anOrderId) throws RemoteException;

    public double getPrice(Integer anOrderId) throws RemoteException;

    public void createOrder(Order o) throws RemoteException;

    public void createOrder(Order o, Integer custId)
            throws RemoteException;

    public int getQueueTime() throws RemoteException;

}
