package de.hanser.buch.opiz.ejb.client;

import java.rmi.RemoteException;
import java.util.List;

import javax.ejb.CreateException;

import org.apache.log4j.xml.DOMConfigurator;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import de.hanser.buch.opiz.domain.Order;
import de.hanser.buch.opiz.domain.OrderFilter;
import de.hanser.buch.opiz.ejb.VisitorServiceEjbHome;
import de.hanser.buch.opiz.ejb.VisitorServiceEjbRemote;
import de.hanser.buch.opiz.service.OrderService;

public class CommandLineEjbClient {

    private OrderService orderService;
    private VisitorServiceEjbHome visitorServiceHome;

    private VisitorServiceEjbRemote visitorServiceRemote; // not autowired

    public void selectOrder() throws Exception {
        OrderFilter filter = new OrderFilter();
        filter.setCustomerName("%oates%");

        System.out.println("Calling orderServiceEjb");

        List<Order> list = orderService.selectOrder(filter);

        System.out.println("Got " + list.size() + " orders");
    }

    public void countVisitors(ApplicationContext appCtx)
            throws CreateException, RemoteException {
        if (visitorServiceRemote == null) {

            // bean is now injected
//            VisitorServiceEjbHome visitorServiceHome = (VisitorServiceEjbHome) appCtx
//                    .getBean("visitorServiceHome");

            System.out.println("Calling home.create");
            visitorServiceRemote = visitorServiceHome.create();
        }
        visitorServiceRemote.addVisitor();
        System.out.println("Anzahl Besucher: "
                + visitorServiceRemote.getNbrVisitors());
    }

    public void setOrderService(OrderService anOrderService) {
        this.orderService = anOrderService;
    }

    public void setVisitorServiceHome(
            VisitorServiceEjbHome visitorServiceHome) {
        this.visitorServiceHome = visitorServiceHome;
    }

    public static void main(String[] args) throws Exception {
        DOMConfigurator.configure("client-cfg/log4j.xml");

        ApplicationContext appCtx = new ClassPathXmlApplicationContext(
                "clientContext-ejb.xml");
        CommandLineEjbClient client = (CommandLineEjbClient) appCtx
                .getBean("ejbClient");

        client.selectOrder();

        for (int i = 0; i < 1; i++) {
            client.countVisitors(appCtx);
        }
    }

}
