package de.hanser.buch.opiz.ejb.test;

import java.io.OutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import junit.framework.TestSuite;
import junit.textui.TestRunner;

import org.jboss.system.ServiceMBeanSupport;

public class OpizTestRunner extends ServiceMBeanSupport implements
        OpizTestRunnerMBean {

    private static final String NEWLINE = System
            .getProperty("line.separator");

    private static List<String> tests;

    // hardcoded for now
    static {
        List<String> tmp = new ArrayList<String>();
        tmp.add("de.hanser.buch.opiz.dao.HibernateOrderDaoImplTest");
        tmp.add("de.hanser.buch.opiz.dao.HibernatePizzaDaoImplTest");
        tmp
                .add("de.hanser.buch.opiz.dao.HibernateToppingDaoImplAutowireByNameTest");
        tmp
                .add("de.hanser.buch.opiz.dao.HibernateToppingDaoImplTest");
        tmp.add("de.hanser.buch.opiz.domain.OrderTest");
        tmp.add("de.hanser.buch.opiz.service.OrderServiceMockTest");
        tmp.add("de.hanser.buch.opiz.service.OrderServiceTest");

        tests = tmp;
    }

    public String listTests() {

        StringBuffer sb = new StringBuffer(100);
        sb.append("Folgende Tests stehen zur Verfuegung:").append(
                NEWLINE);
        for (Iterator<String> iter = tests.iterator(); iter.hasNext();) {
            String test = iter.next();
            sb.append(test).append(NEWLINE);
        }
        return sb.toString();
    }

    public String runTests() throws ClassNotFoundException {
        TestSuite suite = new TestSuite("opiz Tests");

        StringBuffer sb = new StringBuffer(200);

        for (Iterator<String> iter = tests.iterator(); iter.hasNext();) {
            String test = iter.next();
            suite.addTestSuite(Class.forName(test));
        }

        sb.append(doRun(suite));

        return sb.toString();
    }

    /**
     * Execute one test suite (internal method).
     *
     * @param testSuite
     * @return
     */
    private String doRun(final TestSuite testSuite) {
        final StringBuffer BUFFER = new StringBuffer();

        BUFFER.append(testSuite.countTestCases())
                .append(" Tests werden ausgefuehrt").append(NEWLINE);
        BUFFER.append("Test-Ausgabe:").append(NEWLINE);

        PrintStream out = new PrintStream(new OutputStream() {
            @Override
            public void write(int b) {
                BUFFER.append((char) b);
            }
        });

        TestRunner runner = new TestRunner(out);
        runner.doRun(testSuite);

        return BUFFER.toString();
    }

    @Override
    public String getName() {
        return "opiz-TestRunner";
    }

}
