package de.hanser.buch.opiz.rmi.client;

import java.util.Iterator;
import java.util.List;

import org.apache.log4j.xml.DOMConfigurator;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import de.hanser.buch.opiz.domain.Order;
import de.hanser.buch.opiz.domain.OrderFilter;
import de.hanser.buch.opiz.service.OrderService;

public class CommandLineRmiClient {

    private OrderService orderService;

    public void selectOrder() throws Exception {
        OrderFilter filter = new OrderFilter();
        filter.setCustomerName("%oates%");

        System.out.println("Rufe orderService");

        List<Order> list = orderService.selectOrder(filter);

        System.out.println("Gefundene Datensaetze: " + list.size());
        for (Iterator<Order> iter = list.iterator(); iter.hasNext();) {
            Order order = iter.next();
            //aufpassen mit lazy-loading (e.g. getPrice)
            System.out.println(order.getId() + ", state: " + order.getState());
        }
    }

    public void setOrderService(OrderService anOrderService) {
        this.orderService = anOrderService;
    }

    public static void main(String[] args) throws Exception {
        DOMConfigurator.configure("client-cfg/log4j.xml");

        ApplicationContext appCtx = new ClassPathXmlApplicationContext(
                "clientContext-rmi.xml");
        CommandLineRmiClient client = (CommandLineRmiClient) appCtx
                .getBean("rmiClient");

        client.selectOrder();
    }

}
