<%@ page contentType="text/html"%>
<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>

<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<%@ include file="../base/includeHeader.jsp"%>
<body>
<f:view>
	<%@ include file="../top.jsp"%>
	<h:form id="form">
		<h3>Offene Bestellungen</h3>
		<table>
			<h:outputText value="Keine offenen Bestellungen vorhanden." rendered="#{openOrders.rowCount == 0}"/>
			<h:dataTable value="#{openOrders}" var="order" rendered="#{openOrders.rowCount > 0}" border="1">
				<h:column>
					<h:commandLink id="viewOpenOrderLink" action="selectOpenOrder">
						<h:outputText value="#{order.creationTime}">
							<f:convertDateTime pattern="dd.MM.yyyy HH:mm:ss"/>
						</h:outputText>
					</h:commandLink>
				</h:column>
				<h:column>
					<h:outputText value="#{order.customer.name}" />
				</h:column>
				<h:column>
					<h:outputText value="#{order.customer.address.street}" />,
					<h:outputText value="#{order.customer.address.zip}" />&nbsp;<h:outputText
						value="#{order.customer.address.city}" />
				</h:column>
				<h:column>
					<h:outputText value="#{order.state}" style="#{order.state == 'DELIVERED' ? 'color:red': ''}" />
				</h:column>
				<h:column>
					<h:dataTable value="#{order.pizzas}" var="pizza" border="1">
						<h:column>
							<h:outputText value="#{pizza.name}" />
						</h:column>
						<h:column>
							<h:dataTable value="#{pizza.toppings}" var="topping" border="1">
								<h:column>
									<h:outputText value="#{topping.name}" />
								</h:column>
							</h:dataTable>
						</h:column>
					</h:dataTable>
				</h:column>
			</h:dataTable>
			<p/>
			<tr>
				<td colspan="2" class="buttonBar">
					<h:commandButton type="submit" value="nderungen bernehmen" action="commit" immediate="false" />
					<h:commandButton type="submit" value="Abbruch" action="cancel" immediate="false" />
				</td>
			</tr>
		</table>
	</h:form>
</f:view>
</body>
</html>
