package de.hanser.buch.opiz.dao;

import de.hanser.buch.opiz.domain.Customer;

import java.util.List;

/**
 * DAO fuer Kunden.
 * 
 */
public interface CustomerDao {

    Customer getCustomer(Integer customerId);

    Integer saveCustomer(Customer customer);

    /**
     * Aktualisiert einen Kunden.
     * 
     * @param customer
     *            der Kuunde
     */
    void updateCustomer(Customer customer);

    // TODO: Diese Methode wird nie benutzt - SWI
    Customer selectCustomerByUsername(String name);

    /**
     * Liefert eine Liste aller Kunden.
     * 
     * @return eine Liste aller Kunden.
     */
    List<Customer> getAllCustomers();

    // TODO: Diese Methode wird nie benutzt - SWI
    /**
     * F�gt eine Customer zur aktuellen Session hinzu.
     * 
     * @param customer Der Kunde
     */
    void attachCustomer(Customer customer);

    /**
     * Gibt zurück wie oft ein Kunden bestellt hat.
     * 
     * @param customer
     *            der Kunde
     */
    int getNumberOrders(Customer customer);
}
