package de.hanser.buch.opiz.dao;

import static de.hanser.buch.opiz.Constants.FUNC_LOG;
import static de.hanser.buch.opiz.Constants.LOG_MSG_ORDER_NEW_OR_CHANGED;
import de.hanser.buch.opiz.domain.Customer;
import de.hanser.buch.opiz.domain.Order;
import de.hanser.buch.opiz.domain.OrderFilter;
import de.hanser.buch.opiz.domain.OrderState;
import org.hibernate.SessionFactory;

import java.util.List;

/**
 * Benutzt keine Spring-Klassen.
 * <p>
 * NB: nicht vollstaendig implementiert.
 */
public class HibernateOrderDaoWithoutSpringImpl implements OrderDao {

    private SessionFactory sessionFactory;

    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }

    /**
     * {@inheritDoc}
     */
    public Order getOrder(Integer id) {
        return (Order) sessionFactory.getCurrentSession().get(Order.class, id);
    }

    /**
     * {@inheritDoc}
     */
    public Integer saveOrder(Order anOrder) {
        sessionFactory.getCurrentSession().saveOrUpdate(anOrder);
        FUNC_LOG.info(LOG_MSG_ORDER_NEW_OR_CHANGED + anOrder.getId());
        return anOrder.getId();
    }

    public List<Order> getOrdersForCustomer(Customer customer) {
        // nicht implementiert
        return null;
    }

    public List<Order> getOrdersInState(OrderState state) {
        // nicht implementiert
        return null;
    }

    public List<Order> selectOrder(OrderFilter filter) {
        // nicht implementiert
        return null;
    }

    public List<Order> selectOrderByExample(Order exampleOrder) {
        // nicht implementiert
        return null;
    }

}
