package de.hanser.buch.opiz.dao;

import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import de.hanser.buch.opiz.domain.Pizza;

/**
 * Implementierung des Pizza-DAOs.
 * <p>
 * @author dr richard oates
 */
public class HibernatePizzaDaoImpl extends HibernateDaoSupport implements PizzaDao {

    private static final Logger LOG = Logger
            .getLogger(HibernatePizzaDaoImpl.class);

    /** {@inheritDoc} */
    @SuppressWarnings("unchecked")
    public List<Pizza> selectAll() {
        return getHibernateTemplate().loadAll(Pizza.class);
    }

    public Integer savePizza(Pizza aPizza) {
        LOG.debug("flush mode: "
                + getHibernateTemplate().getFlushMode());
        return (Integer) getHibernateTemplate().save(aPizza);
    }

    public Pizza getPizza(Integer pizzaId) {
        return (Pizza) getHibernateTemplate().get(Pizza.class,
                pizzaId);
    }

    public void update(Pizza aPizza) {
        getHibernateTemplate().update(aPizza);
    }
    
}
