package de.hanser.buch.opiz.dao.stp;

import de.hanser.buch.opiz.domain.Customer;
import de.hanser.buch.opiz.domain.Order;
import de.hanser.buch.opiz.domain.OrderState;
import org.springframework.jdbc.core.RowMapper;

import java.sql.ResultSet;
import java.sql.SQLException;


/**
 * Ein RowMapper-Objekt, um zwischen einem ResultSet und einem Order-Objekt zu mappen. 
 * @author dr richard oates
 *
 */
public class OrderMapper implements RowMapper {

    public Object mapRow(ResultSet rs, int rowNum) throws SQLException {
        Order order = new Order();
        order.setId(rs.getInt("id"));
        Customer customer = new Customer();
        customer.setName(rs.getString("customer"));
        order.setCustomer(customer);
        order.setState(OrderState.valueOf(rs.getString("state")));
        return order;
    }

}
