package de.hanser.buch.opiz.domain;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import java.io.Serializable;

/**
 * Repraesentiert eine Adresse.
 * 
 */
@SuppressWarnings("serial")
@Entity
public class Address implements Serializable {

    private Integer id;
    
    private String street;

    private String city;

    private Integer zip;

    /**
     * Default-Konstruktor fuer Hibernate.
     */
    public Address() {
    }

    /**
     * Konstruktor zur Initialisierung.
     * @param street die Strae
     * @param zip die Postleitzahl
     * @param city die Stadt
     */
    public Address(String street, Integer zip, String city) {
        super();
        this.street = street;
        this.city = city;
        this.zip = zip;
    }



    /**
     * Der Primaerschluessel des Kunden.
     */
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getStreet() {
        return street;
    }

    public void setStreet(String street) {
        this.street = street;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public Integer getZip() {
        return zip;
    }

    public void setZip(Integer zip) {
        this.zip = zip;
    }
}
