package de.hanser.buch.opiz.domain;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Hilfs-Klasse Filtern von Bestellungen.<p/>
 * Jedes gesetzte Attribut (non-null) entspricht einer 'where'-Klausel in
 * der SQL-Abfrage. Wenn zum Beispiel 'name' gesetzt ist, wird ein
 * <pre>select from orders where name like 'xxx%'</pre>
 * ausgeführt. <p/>
 * 
 * @author dr richard oates
 */
public class OrderFilter implements Serializable {
    
    private static final long serialVersionUID = 1L;

    private String customerName;

    private List<Integer> pizzas;

    private OrderState state;

    private Date creationTime;

    public Date getCreationTime() {
        return creationTime;
    }

    public void setCreationTime(Date creationTime) {
        this.creationTime = creationTime;
    }

    public String getCustomerName() {
        return customerName;
    }

    public void setCustomerName(String customerName) {
        this.customerName = customerName;
    }

    public List<Integer> getPizzas() {
        return pizzas;
    }

    public void setPizzas(List<Integer> pizzas) {
        this.pizzas = pizzas;
    }
    
    public void addPizzaId(int id) {
        if (this.pizzas == null) {
            this.pizzas = new ArrayList<Integer>();
        }
        this.pizzas.add(id);
    }

    public OrderState getState() {
        return state;
    }

    public void setState(OrderState state) {
        this.state = state;
    }

}