package de.hanser.buch.opiz.service;

import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.BeanPostProcessor;


/**
 * Die Klasse zaehlt die Anzahl der instanziierten Objekte. 
 * @author Gerald Bachlmayr
 *
 */
public class ObjectInstanceCounter implements BeanPostProcessor {
	
	private int counter;
	
	public int getCounter() {
		return counter;
	}

	public Object postProcessBeforeInitialization(Object bean, String beanName) throws BeansException {
		System.out.println("~~~~~~~~~~~~~~ COUNTER: " + counter);		
		return bean;
	}

	public Object postProcessAfterInitialization(Object bean, String beanName) throws BeansException {
		System.out.println("~~~~~~~~~~~~~~ COUNTER: " + counter);
		counter++;
		return bean;
	}

}
