package de.hanser.buch.opiz.service;

import org.springframework.transaction.annotation.Transactional;

/**
 * Die Visitor-Service Schnittstelle.
 * Wird als ein Beispiel einer Stateful-Session-Bean implementiert.
 * <p>
 * @author dr richard oates
 *
 */
@Transactional(readOnly = true)
public interface VisitorService {
    /**
     * Inkrementiert die Anzahl der Besucher.
     */
    public void addVisitor();

    /**
     * Dekrementiert die Anzahl der Besucher.
     */
    public void removeVisitor();

    /**
     * Gibt den Anzahl Besucher zurueck.
     */
    public int getNbrVisitors();
}
