package de.hanser.buch.opiz.service;

import org.apache.log4j.Logger;

import java.io.Serializable;

/**
* Die Implementierung der Visitor-Service-Schnittstelle.
* <p>
* @author dr richard oates
*
*/
public class VisitorServiceImpl implements VisitorService,
        Serializable {

    private static final long serialVersionUID = 1L;

    private static final Logger LOG = Logger
            .getLogger(VisitorServiceImpl.class);

    // static ==> shared over all instances of stateful bean
    private static int nbrVisitors = 0;

    public void addVisitor() {
        LOG.debug(this.toString());
        nbrVisitors++;
    }

    public void removeVisitor() {
        LOG.debug(this.toString());
        if (nbrVisitors > 0) {
            nbrVisitors--;
        }
    }

    public int getNbrVisitors() {
        LOG.debug(this.toString());
        return nbrVisitors;
    }

    @Override
    public String toString() {
        return "[" + super.toString() + ", nbrVisitors: "
                + nbrVisitors;
    }
}
