package de.hanser.buch.opiz.dao;

import java.util.List;

import org.springframework.test.annotation.AbstractAnnotationAwareTransactionalTests;

import de.hanser.buch.opiz.domain.Topping;
import de.hanser.buch.opiz.domain.ToppingPriceCategory;

/**
 * Diese Test prueft ob Autowire bei Name funktioniert.
 * 
 * @author richard oates
 */
public class HibernateToppingDaoImplAutowireByNameTest extends
		AbstractAnnotationAwareTransactionalTests {

	private ToppingDao toppingDao;

	public HibernateToppingDaoImplAutowireByNameTest() {
		super();
		this.setAutowireMode(AUTOWIRE_BY_NAME);
	}

	// Verwendet "Object" als Typ, um autowire_by_name zu demonstrieren
	public void setToppingDao(Object toppingDao) {
		this.toppingDao = (ToppingDao) toppingDao;
	}

	public void testSelectByNameOneResult() {
		List<Topping> list = toppingDao.getToppingByName("Tomato");
		assertEquals("Liste sollte ein Eintrag haben", 1, list.size());
		assertEquals("Falscher Name", "Tomato sauce", list.get(0).getName());
	}

	@Override
	protected void onSetUpInTransaction() throws Exception {
		JDBCTestHelper.insertTopping(jdbcTemplate, 1, "Tomato sauce",
				ToppingPriceCategory.ONE);
		JDBCTestHelper.insertTopping(jdbcTemplate, 2, "Edam",
				ToppingPriceCategory.TWO);
		JDBCTestHelper.insertTopping(jdbcTemplate, 3, "Salami",
				ToppingPriceCategory.TWO);
	}

	@Override
	protected String[] getConfigLocations() {
		return new String[] { "applicationContext.xml" };
	}

}
