package de.hanser.buch.opiz.service;

import org.springframework.test.AbstractDependencyInjectionSpringContextTests;

/**
 * Die Klasse testet das Anlegen eines zweiten Kontextes. Dabei wird
 * ersichtlich, dass die Datei mit dem gleichen Inhalt, aber unterschiedlichem
 * Name, das Anlegen eines neuen App-Ctx bewirkt.
 * 
 * @author Gerald Bachlmayr
 * 
 */

public class ApplicationContextTest2 extends
        AbstractDependencyInjectionSpringContextTests {

    public void testEnvironment1() {
        System.out.println("Test 1: " + applicationContext.getDisplayName()
                + ", hashCode: " + applicationContext.hashCode());
    }

    public void testEnvironment2() {
        System.out.println("Test 2: " + applicationContext.getDisplayName()
                + ", hashCode: " + applicationContext.hashCode());
    }

    @Override
    protected String[] getConfigLocations() {
        if (getName().equals("testEnvironment2")) {
            return new String[] { "applicationContextCopy.xml" };
        } else {
            return new String[] { "applicationContext.xml" };
        }
    }

}
