package de.hanser.buch.opiz.service;

import de.hanser.buch.opiz.domain.Address;
import de.hanser.buch.opiz.domain.Customer;
import de.hanser.buch.opiz.domain.Order;
import de.hanser.buch.opiz.domain.Pizza;
import de.hanser.buch.opiz.domain.Topping;
import de.hanser.buch.opiz.domain.ToppingPriceCategory;

import java.util.ArrayList;
import java.util.List;

/**
 * Anlegen von Testdaten
 * @author Gerald Bachlmayr
 *
 */

public class TestUtil {
	
    public static Order createTestOrder1() {
    	Topping topping1 = new Topping("cheese", ToppingPriceCategory.TWO);
        Topping topping2 = new Topping("tomato", ToppingPriceCategory.THREE);
        
        List<Topping> toppings1 = new ArrayList<Topping>();
        toppings1.add(topping1);
        toppings1.add(topping2);
                
        Pizza pizza1 = new Pizza("my pizza 1", toppings1);
        
    	Order order1 = new Order();
        order1.addPizza(pizza1);
        order1.addPizza(createPizza2());
        order1.setCustomer(createCustomer());
        
        return order1;
    }
    
    public static Order createTestOrder2() {
    	Order order2 = new Order();
    	order2.addPizza(createPizza2());
    	order2.setCustomer(createCustomer());
    	return order2;
    }
    
    public static Customer createCustomer() {
        Customer cust1 = new Customer();
        cust1.setName("Gerry B.");
        cust1.setUsername("geba1nz");
        cust1.setPassword("***");
        cust1.setVersion(1);
        return cust1;
    }
    
    private static Pizza createPizza2() {
    	List<Topping> toppings2 = new ArrayList<Topping>();
        toppings2.add(new Topping("paprika", ToppingPriceCategory.TWO));
        toppings2.add(new Topping("cheddar", ToppingPriceCategory.THREE));
        
    	return new Pizza("my pizza 2", toppings2);
    }
    
    public static Address createAddress() {
    	  Address addr = new Address();
          addr.setCity("Auckland");
          addr.setId(1);
          addr.setStreet("98 Kitchener Road, Milford");
          addr.setZip(10);
          return addr;
    }

}
